package code;

import java.io.IOException;
import java.net.URI;
import java.util.ArrayList;
import java.util.List;

import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;

public class Scenari implements HttpHandler {

	@Override
	public void handle(HttpExchange exchange) throws IOException {
		URI requestURI = exchange.getRequestURI();
		String path[] = requestURI.toString().split("/");
		String lastfile = path[path.length - 1];

		String requestMethod = exchange.getRequestMethod();
		List<String> strlist = new ArrayList<>(); //serve List<String> a causa di .put("content-type", strlist);
		strlist.add("text/json");
		exchange.getResponseHeaders().put("content-type", strlist);//opzionale, per dire cosa c'e' nel body
		
		if(Helper.compareText(lastfile,"scenari")) {//get {nome e data di tutti gli scenari}
			if(Helper.compareText(requestMethod,"GET")) {
				String response = "[{\"nome\":\"natale\",\"data\":\"2021-12-25\",\"stato\":true},{\"nome\":\"serata disco\",\"data\":\"2022-04-23\",\"stato\":false},{\"nome\":\"compleanno\",\"data\":\"2022-02-27\",\"stato\":true}]";
				Helper.sendResponse(response,exchange);
			} else {
				Helper.methodNotAllowed(exchange);
			}
			return;
		}
		
		if(Helper.compareText(lastfile,"attiva")) {//put {attiva/disattiva}
			if(Helper.compareText(requestMethod,"PUT")) {
				String body = Helper.readBody(exchange.getRequestBody());
				if(!Helper.checkJSON(body) || !body.contains("\"stato\"") || !body.contains("\"nome\"")) {
					Helper.badRequest(exchange);
					return;
				}
				String stato = body.split("\"stato\"",2)[1].split(":",2)[1].split(",",2)[0].split("}",2)[0].trim();

				String nome = body.split("\"nome\"",2)[1].split("\"",3)[1].trim();
				try	{
					boolean st = Boolean.parseBoolean(stato);
					
					String response = "{\"nome\":\""+nome+"\",\"stato\":"+st+"}";
					Helper.sendResponse(response,exchange);
				} catch (Exception e) {
					System.out.println("Conversion error.\t"+stato);
					e.printStackTrace();
					Helper.badRequest(exchange);
				}
			} else {
				Helper.methodNotAllowed(exchange);
			}
			return;
		}
		
		if(Helper.compareText(lastfile,"registra")) {//put {registra/termina}
			if(Helper.compareText(requestMethod,"PUT")) {
				String body = Helper.readBody(exchange.getRequestBody());
				if(!Helper.checkJSON(body) || !body.contains("\"registra\"")) {
					Helper.badRequest(exchange);
					return;
				}
				String stato = body.split("\"registra\"",2)[1].split(":",2)[1].split(",",2)[0].split("}",2)[0].trim();
				try	{
					boolean st = Boolean.parseBoolean(stato);
					
					String response = "{\"registra\":"+st+"}";
					Helper.sendResponse(response,exchange);
				} catch (Exception e) {
					System.out.println("Conversion error.\t"+stato);
					e.printStackTrace();
					Helper.badRequest(exchange);
				}
			} else {
				Helper.methodNotAllowed(exchange);
			}
			return;
		}
		
		if(Helper.compareText(lastfile,"salva")) {//post {conferma salvataggio, altrimenti cancella dopo timer; ritorna i valori dello scenario}
			if(Helper.compareText(requestMethod,"POST")) {
				String body = Helper.readBody(exchange.getRequestBody());
				if(!Helper.checkJSON(body) || !body.contains("\"nome\"")) {
					Helper.badRequest(exchange);
					return;
				}
				String nome = body.split("\"nome\"",2)[1].split("\"",3)[1].trim();
				String response = "{\"salvato\":\""+nome+"\"}";
				Helper.sendResponse(response,exchange);
			} else {
				Helper.methodNotAllowed(exchange);
			}
			return;
		}
		
		Helper.pageNotFound(exchange);
	}

}
